#include<bits/stdc++.h>
using namespace std;
int a[50001],b[50001],c[50001],d[50001];
int main()
{
    int n,m;
    long long sum;
    cin >> n >> m;
    for(int i=0;i<n;i++)
    {
        cin >> a[i] >> b[i];
    }
      for(int i=0;i<m;i++)
    {
        cin >> c[i] >> d[i];
    }

    if(n==1)
    {
        sum=0;
        for(int i=0;i<m;i++)
        {
            sum+=d[i];
        }
        bool bool1=false;
        if(sum<b[0])
        {
            bool1=true;
            cout << sum <<endl;
        }
        else
        {
            cout << b[0]<<endl;
        }
        long long sum2=0;
        int k=0;
        for(int i=0;i<m;i++)
        {
            if(sum2==sum)
            {
                break;
            }
            if(sum2+d[i]<=sum)
            {
                sum2+=d[i];
                if(d[i]>0)
                k++;
            }
            else
            {
                k++;
                sum2=sum;
            }
        }
        cout << k << endl;
        sum2=0;
        for(int i=0;i<m;i++)
        {
            if(sum2==sum)
            {
                break;
            }
            if(sum2+d[i]<=sum)
            {
                sum2+=d[i];
                if(d[i]>0)
                cout << 1 <<" " <<i+1 <<" " << d[i]<<endl;
            }
            else
            {
                cout << 1 << " "<<i+1<<" "<<sum-sum2<<endl;
                sum2=sum;
            }
        }
    }
}